#include <stdio.h>
#include "global.h"
#include "mbuf.h"
#include "socket.h"
extern int32 Ip_addr;

main(argc,argv)
int argc;
char *argv[];
{
	struct sockaddr_in sock;
	char *cp;
	int s,i;
	struct mbuf *bp;

	if (argc < 2) {
		fprintf(stderr,"Usage: %s <address> [ ... ]\n",argv[0]);
		exit(1);
	}
	sock.sin_family = AF_INET;
	sock.sin_port = IPPORT_FINGER;
	for(i=1;i<argc;i++){
		if((s = socket(AF_INET,SOCK_STREAM,0)) == -1){
			fprintf(stderr,"Can't create socket\n");
			break;
		}
		cp = strchr(argv[i],'@');
		if(cp != NULLCHAR){
			*cp++ = '\0';
			printf("%s@%s -- ",argv[i],cp);
			if((sock.sin_addr.s_addr = (long) resolve(cp)) == 0){
				fprintf(stderr,"Host %s unknown\n",cp);
				close_s(s);
				continue;
			}
		}
		else {
			sock.sin_addr.s_addr = (long) Ip_addr;
			printf("%s -- ",argv[i]);
		}
		printf("trying %s",psocket((char *)&sock));
		fflush(stdout);
		if(connect(s,(char *)&sock,sizeof(sock)) == -1){
			cp = sockerr(s);
			printf(" -- Connect failed: %s\n",cp != NULLCHAR ? cp : "");
			close_s(s);
			continue;
		}
		printf("\n");
		usprintf(s,"%s\r\n",argv[i]);
		while(recv_mbuf(s,&bp,0,0,NULLCHAR,NULLINT) > 0){
			write_p(stdout,bp);
			fflush(stdout);
			free_p(bp);
		}
		close_s(s);
	}
	iostop();
}
