#ifndef	NULLIF

#include "global.h"

/* Interface control structure */
struct iface {
	struct iface *next;	/* Linked list pointer */
	char *name;		/* Ascii string with interface name */
	int (*ioctl)();		/* Function to handle device control */
	int (*send)();		/* Routine to send an IP datagram */
	int (*output)();	/* Routine to send link packet */
	int (*raw)();		/* Routine to call to send raw packet */
	int (*stop)();		/* Routine to call before detaching */
	int16 mtu;		/* Maximum transmission unit size */
	int16 dev;		/* Subdevice number to pass to send */
	int16 flags;		/* Configuration flags */
#define	DATAGRAM_MODE	0	/* Send datagrams in raw link frames */
#define	CONNECT_MODE	1	/* Send datagrams in connected mode */
	int16 trace;		/* Trace flags */
#define	IF_TRACE_OUT	0x01	/* Output packets */
#define	IF_TRACE_IN	0x10	/* Packets to me except broadcast */
#define	IF_TRACE_ASCII	0x100	/* Dump packets in ascii */
#define	IF_TRACE_HEX	0x200	/* Dump packets in hex/ascii */
	char *hwaddr;		/* Device hardware address, if any */
	struct iface *forw;	/* Forwarding interface for output, if rx only */
};
#define	NULLIF	(struct iface *)0
extern struct iface *Ifaces;	/* Head of interface list */

/* Header put on front of each packet in input queue */
struct phdr {
	struct iface *iface;
	unsigned short type;
#define	TYPE_AX25	0
#define	TYPE_ETHER	1
#define	TYPE_IP		2
#define TYPE_APPLETALK	3
#define	TYPE_KISS	4
#define	TYPE_NETROM	5
#define	NTYPE		6
};

#if	defined(__STDC__) || defined(__TURBOC__)
struct iface *if_lookup(char *name);
#else
struct iface *if_lookup();
#endif

#endif	/* NULLIF */


