#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/termio.h>
#include <sys/fcntl.h>
#include <sys/stat.h>
#include "netdb.h"
#include "mbuf.h"
#include "socket.h"

struct ntab {
    struct ntab *next;
    char proto[80];
    int port;
    char program[80];
    int s;
} *Ntab = (struct ntab *)0;
#define	INITFILE	"./nettab"
main()
{
    struct ntab *n;
    fd_set fset,tmpset;
    int cnt = 0;
    gobackground();
    readinitfile();
    setupsockets();
    n = Ntab;
    FD_ZERO(&fset);
    while(n != (struct ntab *)0){
	if(n->s != -1) {
	    FD_SET(n->s,&fset);
	    ++cnt;
	}
	n = n->next;
    }
    if(cnt == 0)
	if(Ntab == (struct ntab *)0)
	    exit(0);
	else
	    iostop();
    for(;;){
	tmpset = fset;
	if(select(xgetdtablesize(),&tmpset,(fd_set *)0,(fd_set *)0,
		  (struct timeval *)0) > 0) {
	    n = Ntab;
	    while(n != (struct ntab *)0){
		if(FD_ISSET(n->s,&tmpset))
		    handleconn(n);
		n = n->next;
	    }
	}
    }
}
gobackground()
{
    int i;
    close(0);
    close(1);
    close(2);
    open("/",O_RDONLY);
    dup2(0,1);
    dup2(0,2);
    if ((i = open("/dev/tty",O_RDWR)) > 0) {
	ioctl(i,TIOCNOTTY,0);
	close(i);
    }
    if (fork())
	exit(0);
}

readinitfile()
{
    char buf[255],proto[80],service[80],program[80];
    FILE *fp;
    struct ntab *n = (struct ntab *)0;
    struct servent *sp;
    if(!(fp = fopen(INITFILE,"r")))
	return;
    while(fgets(buf,255,fp)) {
	if(buf[0] == '#' || buf[0] == '\n')
	    continue;
	sscanf(buf,"%s%s%s",proto,service,program);
	if(!(sp = getservbyname(service,proto)))
	    continue;
	if(n) {
	    n->next = (struct ntab *)calloc(1,sizeof(*Ntab));
	    n = n->next;
	}
	else
	    n = Ntab = (struct ntab *)calloc(1,sizeof(*Ntab));
	n->port = sp->s_port;
	strcpy(n->proto,proto);
	strcpy(n->program,program);
    }
    fclose(fp);
}

setupsockets()
{
    struct ntab *n;
    struct sockaddr_in sock;
    int domain,type;
    for(n = Ntab; n; n = n->next) {
        if(!strnicmp("tcp",n->proto,strlen(n->proto))) {
            domain = AF_INET;
            type = SOCK_STREAM;
        }
        else
            if(!strnicmp("ax25",n->proto,strlen(n->proto))) {
                domain = AF_AX25;
                type = SOCK_STREAM;
            }
            else
                if(!strnicmp("netrom",n->proto,strlen(n->proto))) {
                    domain = AF_NETROM;
                    type = SOCK_SEQPACKET;
                }
                else
                    continue;
        if((n->s = socket(domain,type,0)) == -1)
            continue;
        if(domain == AF_INET) {
            sock.sin_family = domain;
            sock.sin_port = n->port;
            sock.sin_addr.s_addr = Ip_addr;
            if(bind(n->s,&sock,sizeof(struct sockaddr_in)) == -1) {
                close_s(n->s);
                n->s = -1;
                continue;
            }
        }
        if(listen(n->s,5) == -1) {
            close_s(n->s);
            n->s = -1;
        }
    }
}

handleconn(n)
struct ntab *n;
{
    char buf[255];
    int len = 255;
    int s;
    FILE *master,*slave;
    int pid1,pid2;
    if((s = accept(n->s,buf,&len)) == -1)
	return;
    signal(SIGCHLD,SIG_IGN);
    if(xfork()) {
	close_s(s);
	return;
    }
    close_s(n->s);
    if(getptys(&master,&slave) == -1)
	exit(0);
    if((pid1 = xfork()) == 0) {
	fclose(slave);
	sockreader(s,master);
	exit(0);
    }
    if((pid2 = xfork()) == 0) {
	fclose(master);
	startslave(slave,n->program,buf);
	exit(0);
    }
    fclose(slave);
    slavereader(s,master);
    kill(pid1,SIGTERM);
    kill(pid2,SIGHUP);
    exit(0);
}
int
getptys(m,s)
FILE **m, **s;
{
    int ok = 0, i;
    struct stat statbuf;
    char line[12], c;
    strcpy(line,"/dev/pty  ");
    for(c = 'p'; !ok && c <= 's'; ++c) {
	line[strlen("/dev/pty")] = c;
	line[strlen("/dev/ptyp")] = '0';
	if(stat(line,&statbuf) == -1)
	    break;
	for(i=0; i < 16; ++i) {
	    if(i < 10)
		line[strlen("/dev/ptyp")] = '0' + i;
	    else
		line[strlen("/dev/ptyp")] = 'a' + i - 10;
	    if((*m = fopen(line,"w+")) != NULL) {
		ok = 1;
		break;
	    }
	}
    }
    if(!ok)
	return -1;
    line[strlen("/dev/")] = 't';
    if((*s = fopen(line,"w+")) == NULL)
	return -1;
    return 0;
}

startslave(slave,program,sock)
FILE *slave;
char *program, *sock;
{
    char *arg;
    struct termio b;
    ioctl(fileno(slave),TCGETA,&b);
    b.c_iflag = IGNCR | BRKINT | IXON | ISTRIP /* | INLCR */;
    ioctl(fileno(slave),TCSETAF,&b);
    dup2(fileno(slave),0);
    dup2(0,1);
    dup2(0,2);
    if(fileno(slave) > 2)
	fclose(slave);
    arg = strrchr(program,'/');
    if(arg)
	++arg;
    else
	arg = program;
    execl(program,arg,psocket(sock),(char *)0);
}

slavereader(s,master)
int s;
FILE *master;
{
    long cnt;
    struct mbuf *bp;
    do {
	cnt = 0;
	ioctl(fileno(master),FIONREAD,&cnt);
	cnt = cnt > 2048 ? cnt : 2048;
	bp = alloc_mbuf(cnt);
	if((bp->cnt = fread(bp->data,1,cnt,master)) == 0) {
	    break;
	}
    } while(send_mbuf(s, bp, 0, (char *)0, 0) != -1);
    free_mbuf(bp);
    fclose(master);
    close_s(s);
#ifdef notdef
    while(socklen(s,1) > 0) /* wait until all data is sent */
	sleep(1);
#endif
}

sockreader(s,master)
int s;
FILE *master;
{
    struct mbuf *bp;
    struct termio b;
    ioctl(fileno(master),TCGETA,&b);
    b.c_oflag = 0;
    ioctl(fileno(master),TCSETAF,&b);
    while(recv_mbuf(s,&bp,0,0,(char *)0,(int *)0) > 0) {
	if(write_p(master,bp) == -1) {
		free_p(bp);
		close_s(s);
		fclose(master);
		return;
	}
	fflush(master);
	free_p(bp);
    }
    close_s(s);
    fclose(master);
}


