/* Global structures and constants needed by an Internet user process */
#ifndef	NCONN

#include "global.h"

#define	NCONN	20		/* Maximum number of open network connections */

extern int32 Ip_addr;	/* Our IP address */
extern int Net_error;	/* Error return code */
#define	NONE	0		/* No error */
#define	CON_EXISTS	1	/* Connection already exists */
#define	NO_CONN	2		/* Connection does not exist */
#define	CON_CLOS	3	/* Connection closing */
#define	NO_SPACE	4	/* No memory for TCB creation */
#define	WOULDBLK	5	/* Would block */
#define	NOPROTO		6	/* Protocol or mode not supported */
#define	INVALID		7	/* Invalid arguments */

/* Codes for the tcp_open call */
#define	TCP_PASSIVE	0
#define	TCP_ACTIVE	1
#define	TCP_SERVER	2	/* Passive, clone on opening */

/* Socket structure */
struct socket {
	int32 address;		/* IP address */
	int16 port;		/* port number */
};
#define	NULLSOCK	(struct socket *)0

/* Connection structure (two sockets) */
struct connection {
	struct socket local;
	struct socket remote;
};
#if	defined(__STDC__) || defined(__TURBOC__)
int32 dresolve(char *name);
int32 resolve(char *name);
#else
int32 dresolve();
int32 resolve();
#endif

int32 aton(),resolve();
char *inet_ntoa(),*psocket();


#endif	/* NCONN */
