#ifndef	SLIP_ALLOC
#include "global.h"

/* SLIP definitions */
#define	SLIP_ALLOC	40	/* Receiver allocation increment */

#define	FR_END		0300	/* Frame End */
#define	FR_ESC		0333	/* Frame Escape */
#define	T_FR_END	0334	/* Transposed frame end */
#define	T_FR_ESC	0335	/* Transposed frame escape */

/* Slip protocol control structure */
struct slip {
	struct iface *iface;
	struct mbuf *sndq;	/* Encapsulated packets awaiting transmission */
	int16 sndcnt;		/* Number of datagrams on queue */
	char escaped;		/* Receiver State control flag */
	struct mbuf *rbp;	/* Head of mbuf chain being filled */
	struct mbuf *rbp1;	/* Pointer to mbuf currently being written */
	char *rcp;		/* Write pointer */
	int16 rcnt;		/* Length of mbuf chain */
	struct mbuf *tbp;	/* Transmit mbuf being sent */
	int16 errors;		/* Receiver input errors */
	int type;		/* Protocol of input */
};
extern struct slip Slip[];
#if	defined(__STDC__) || defined(__TURBOC__)
int slip_send(struct mbuf *data,struct iface *iface,int32 gateway,int prec,
	int del,int tput,int rel);
int slip_raw(struct iface *iface,struct mbuf *data);
void asy_rx(int dev);
void asytxdone(int16 dev);
#else
int slip_send(),slip_raw();
void asy_rx(),asytxdone();
#endif

#endif	/* SLIP_ALLOC */
